// import { useUserStore } from '@/store/user.js'
import config from '@/config'
import { getSession } from '@/utils/auth'
import errorCode from '@/utils/errorCode'
import { toast, showConfirm, tansParams } from '@/utils/common'
import $modal from '@/plugins/modal.js'

let timeout = config.timeout
const baseUrl = config.baseUrl

const request = config => {
  // 是否需要设置 token
  const isSession = config.isSession || false
  let flag = false
  config.header = config.header || {}
  if (isSession) {
    if (getSession()) {
      config.header['cookie'] = 'JSESSIONID=' + getSession()
    } else {
      flag = true
      uni.showModal({
        title: '系统提示',
        content: '登录状态已过期，您可以继续留在该页面，或者重新登录?',
        cancelText: '取消',
        confirmText: '确定',
        success: function (res) {
          console.log('showModal success');
          
          if (res.confirm) {
            uni.reLaunch({ url: '/pages/login' })
            return
          }
          return
        }
      })
    }
  }
  // get请求映射params参数
  if (config.params) {
    let url = config.url + '?' + tansParams(config.params)
    url = url.slice(0, -1)
    config.url = url
  }
  console.log('request.config', config);
  return new Promise((resolve, reject) => {
    if (flag) {
      reject()
    }
    uni.request({
      method: config.method || 'get',
      timeout: config.timeout || timeout,
      url: config.baseUrl || baseUrl + config.url,
      data: config.data,
      header: config.header,
      dataType: 'json'
    }).then(response => {
      console.log('request.response', response);
      const { statusCode, data } = response
      const returnCode = data.returnCode
      const code = statusCode || 200
      const msg = errorCode[code] || data.returnMsg || errorCode['default']
      if (returnCode == -201) {
        toast(msg)
        reject(returnCode)
        return
      }
      if (code === 401) {
        showConfirm('登录状态已过期，您可以继续留在该页面，或者重新登录?').then(res => {
          // if (res.confirm) {
          // store.dispatch('LogOut').then(res => {
          //   uni.reLaunch({ url: '/pages/login' })
          // })
          // }
        })
        reject('无效的会话，或者会话已过期，请重新登录。')
      } else if (code === 500) {
        toast(msg)
        reject('500')
      } else if (code !== 200) {
        toast(msg)
        reject(code)
      }
      resolve(data)
    })
      .catch(error => {
        console.log('request.error', error);
        let { errMsg } = error
        if (errMsg === 'Network Error') {
          errMsg = '后端接口连接异常'
        } else if (errMsg.includes('timeout')) {
          errMsg = '系统接口请求超时'
        } else if (errMsg.includes('Request failed with status code')) {
          errMsg = '系统接口' + errMsg.substr(errMsg.length - 3) + '异常'
        } else if (errMsg.includes('request:fail')) {
          errMsg = '网络请求失败'
        }
        toast(errMsg)
        reject(error)
      })
  })
}

export default request
